<?php
# 基础配置，此处的配置所有的环境都一样，自动加入到env中
# 区别是，这里的配置优先级大于env中的，而且也无需根据env的变化而更改
$config['base'] = array
(
	# 名称
	'name' => 'Dever元生态系统',
	# 框架名称
	'framework_name' => 'Dever生态系统 初代核心',
	# 基本描述
	'desc' => '高门槛 / 低代码 / 多次元 / 生态化',
	# copyright
	'copyright' => '© 2019-2021 dever.cc,Inc. Licensed under MIT license.',
	# github
	'github' => 'https://github.com/dever-main/framework',
	# web
	'web' => 'http://www.dever.cc/',
	# 当前语言包设置
	'lang' => 'zhcn',
	# 语言包可选
	//'lang_set' => array('zhcn' => '简体中文', 'en' => '英文'),
	'lang_set' => array('zhcn' => '简体中文'),
	# api是否开启，默认关闭，如果开启，则需要在项目下建立api目录，手动指定api，类的方法后缀无需加上_api和_secure_api
	'api' => true,
	# 版本配置
	'version' => '1.0.0 Beta',

	# url默认参数，所有Dever::url生成的链接都会加上这个参数
	//'url' => 'loading=content',
	
	# 开启url中某个字段加密 必须使用route.php先定义url
    //'urlEncode' => array('id'),
    # url的原始路径里包含什么字符，则不加密
    'urlEncodeFilter' => array('tag'),
    # 使用加密解密的方法
    'urlEncodeMethod' => array('Dever::idtostr', 'Dever::strtoid'),
	
	# 是否启用自动过滤功能，必须加载manage包，目前可选的值为：manage（自带的过滤功能，非常简单，小型站点可以开启），bao10jie（必须申请账号）
	//'filter' => array('manage' => 1,'bao10jie' => '账号'),
	//'filter' => array('manage' => 1),

	# 基本数据类型
	'state' => array
	(
		1 => '恢复',
		2 => '删除',
	),

	# 路由结束时要执行的方法
	/*
	'route' => array
	(
		'end' => array
		(
			'main/view.article' => 'main/view.article_end',
		),
	),
	*/
	# 启用全站图片压缩
	//'pic' => 't1',

	# 定义全局的系统类型
	'system_source' => array
	(
	    1 => 'H5',
	    2 => '安卓',
	    3 => 'ios',
	    4 => 'pc',
	    5 => '微信小程序',
	    6 => '微信公众号',
	),

	'system_source_key' => array
	(
		'h5' => 1,
	    'android' => 2,
	    'ios' => 3,
	    'pc' => 4,
	    'wx_applet' => 5,
	    'wx_service' => 6,
	),

	# 全局替换
	//'replace' => array('http://8.131.66.239/' =>'http://virtualbeings.cn/'),

	# 地图
	'map' => array
	(
		'url' => 'https://webapi.amap.com/maps?v=1.4.8&key=a62cd89062d546004f1473814c1499f9',
	),

	# alert提示信息时，是否自动生成uuid，一般用于防止重复提交或者用于记录验证信息
	'create_alert_uuid' => false,
);

$config['template'] = array
(
	# 替换设置 一般用于替换资源，将模板中的（html中的）js等相对url换成绝对url，如果不定义，则默认为../js这样的
	'replace' => array
	(
		'css' => '../css/',
		'js' => '../js/',
		'img' => array('../image/', '../img/'),
		'images' => '../images/',
		'lib' => '../lib/',
		'font' => '../fonts/',
		'script' => '../script/',
	),

	# 模板html文件的所在目录，默认为html
	'path' => 'html',
	
	# assets里使用的模板 注意：定义这个之后，将会强制将本项目模板变成这个 定义成数组的话则为pc和手机版 默认为default
	//'assets' => array('pc', 'm'),
	
	# 定义这个之后，将强制将template的目录改为这个，不定义或不填写，则强制使用为assets定义
	//'template' => 'pc',

	# 模板编译时是否过滤\r\n
	'strip' => false,

	# 是否启用layout 如启用，填写要替换的class或者id即可，具体效果可参考youtube，只加载部分内容，前端请加载pjax.js
	//'layout' => '.content',

	# 编译器与模板对应关系目录，可以为空，为空则一一对应，参考manage
	/*
	'relation' => array
	(
		'task/list' => 'tasks',
	),
	*/

	# 定义组件别名 也可以直接用Dever::setAlias('area', 'marea');
	/*
    'alias' => array
    (
        'area' => 'marea',
    ),
    */
);

return $config;